.TH FEDMSG-LOGGER 1

.SH NAME
fedmsg\-logger \- simply emit messages from the command-line to the fedmsg bus

.SH SYNOPSIS
.B fedmsg\-logger
.RB [ \-\-message
.IR LOGGER_MESSAGE ]
.RB [ \-\-json\-input ]
.RB [ \-\-topic
.IR TOPIC ]
.RB [ \-\-modname
.IR MODNAME ]
.RB [ \-\-cert\-prefix
.IR CERT_PREFIX ]
.RI [ "<common fedmsg options>" ]
.PP
.B fedmsg\-logger
.RB [ \-h | \-\-help ]

.SH DESCRIPTION
.B fedmsg\-logger
is a simple command-line utility to send messages to the fedmsg bus. It
is an ephemeral command, that doesn't bind a 0mq endpoint directly. It
sends its messages to a
.BR fedmsg\-relay (1)
daemon that binds a persistent endpoint that the outside world can
subscribe to.  If the
.BR fedmsg\-relay (1)
service is not running at the address specified in the config, then
.B fedmsg\-logger
will hang until that service becomes available.
.PP
If
.B \-\-message
is not specified, this command accepts messages from stdin.

.SH OPTIONS
.TP
.BR \-h ", " \-\-help
Print an help message and exit
.TP
.BR "\-\-message " LOGGER_MESSAGE
The message to send.
.TP
.BR \-\-json\-input
Take each line of input as JSON.
.TP
.BR "\-\-topic " TOPIC
The topic to which the messages are sent. Defaults to
.I log
if unset.
.TP
.BR "\-\-modname " MODNAME
The module name to which the messages are sent. Defaults to
.I logger
if unset.
.TP
.BR "\-\-cert\-prefix " CERT_PREFIX
Specify a different cert from
.\"FIXME this path is wrong in Debian.
.I /etc/pki/fedmsg

.SH COMMON FEDMSG OPTIONS
.TP
.BR "\-\-io\-threads " IO_THREADS
Number of io threads for 0mq to use
.TP
.BR "\-\-topic\-prefix " TOPIC_PREFIX
Prefix for the topic of each message sent.
.TP
.BR "\-\-post\-init\-sleep " POST_INIT_SLEEP
Number of seconds to sleep after initializing.
.TP
.BR "\-\-config\-filename " CONFIG_FILENAME
Config file to use.
.TP
.BR \-\-print\-config
Simply print out the configuration and exit. No action taken.
.TP
.BR "\-\-timeout " TIMEOUT
Timeout in seconds for any blocking zmq operations.
.TP
.BR "\-\-high\-water\-mark " HIGH_WATER_MARK
Limit on the number of messages in the queue before
blocking.
.TP
.BR "\-\-linger " ZMQ_LINGER
Number of milliseconds to wait before timing out connections.

.SH TOPIC CONSTRUCTION
.PP
The full topic to which the messages are sent is constructed from the
.B topic_prefix
and
.B environment
set in the fedmsg configuration, and the
.BR "\-\-topic " TOPIC
and
.BR "\-\-modname " MODNAME
options this way:
.IP
.BR <topic_prefix> . <environment> . MODNAME . TOPIC

.SH CAVEATS
.PP
Note that when using
.BR \-\-json\-input ,
you must send valid JSON, including the use of double quotes as opposed
to single quotes:
.IP
{"a": 1} is valid JSON.
.IP
{'a': 1} is invalid JSON.

.SH EXAMPLES
.PP
Send a message from standard input in JSON format:
.nf
.RS
echo '{"a": 1}' | fedmsg\-logger \-\-json-input
.RE
.fi
.PP
Send a message to the
.I git.repo.update
topic
.nf
.RS
echo "Hai there." | fedmsg\-logger \-\-modname=git \-\-topic=repo.update
.RE
.fi
.PP
Send a simple message:
.nf
.RS
fedmsg\-logger \-\-message="This is a message."
.RE
.fi
.PP
Send a JSON-format message:
.nf
.RS
fedmsg\-logger \-\-message='{"a": 1}' \-\-json\-input
.RE
.fi

.SH SEE ALSO
.PP
.BR fedmsg\-relay "(1), " fedmsg\-announce (1)

.SH "AUTHORS"
.TP
.BR "The Fedora Infrastructure team" " <\&messaging\-sig@lists\&.fedoraproject\&.org\&>"
.RB "Wrote the " fedmsg " software\&."
.TP
.BR "Nicolas Dandrimont" " <\&olasd@debian\&.org\&>"
Wrote this manpage for the Debian system\&.

.SH "COPYRIGHT"
.br
Copyright \(co 2014 Nicolas Dandrimont
.br
.PP
This manual page was written for the Debian system (and may be used by
others)\&.
.PP
You can redistribute it and/or modify it under the terms of the GNU
Lesser General Public License as published by the Free Software
Foundation; either version 2.1 of the License, or (at your option) any
later version.
.PP
On Debian systems, a copy of the license can be found in the
.I /usr/share/common-licenses/LGPL-2.1
file.
.sp
